/* Like "mp.c", but uses an indirection to array to make it easier to
   use the result from one iteration as the input to the next one. */

#include <stdio.h>
#include <stdlib.h>
#include <omp.h>

#define N 100

double m1[N][N], m2[N][N];
double (*m)[N][N];
double (*tmp)[N][N];

static void matrix_swap()
{
  double (*tmp2)[][N] = m;
  m = tmp;
  tmp = tmp2;
}

static void init_matrix()
{
  int i, j;

  m = &m1;
  tmp = &m2;
  for (i = 0; i < N; i++) {
    for (j = 0; j < N; j++) {
      (*m)[i][j] = ((i == j) ? 1 : 0);
    }
  }
}

static void print_matrix()
{
  int i, j;

  for (i = 0; i < N; i++) {
    for (j = 0; j < N; j++) {
      printf("%g ", (*m)[i][j]);
    }
    printf("\n");
  }
}

int main(int argc, char **argv)
{
  int p;

  p = atoi(argv[1]);

  init_matrix();

  while (p--) {
    int i;
    for (i = 0; i < N; i++) {
      int j;
      for (j = 0; j < N; j++) {
        double v = 0;
        int r;
        for (r = 0; r < N; r++) {
          v += (*m)[i][r] * (*m)[r][j];
        }
        (*tmp)[i][j] = v;
      }
    }
    matrix_swap();
  }

  print_matrix();

  return 0;
}
