/* Given p on the command line, computes the 2^p power of a matrix
   by repeated squaring. */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <omp.h>

#define N 100

double m[N][N];
double tmp[N][N];

void init_matrix()
{
  int i, j;
  for (i = 0; i < N; i++) {
    for (j = 0; j < N; j++) {
      m[i][j] = ((i == j) ? 1 : 0);
    }
  }
}

static void print_matrix()
{
  int i, j;

  for (i = 0; i < N; i++) {
    for (j = 0; j < N; j++) {
      printf("%g ", m[i][j]);
    }
    printf("\n");
  }
}



int main(int argc, char **argv)
{
  int i, j, r;
  int p;

  p = atoi(argv[1]);

  init_matrix();

  while (p--) {
#pragma omp parallel for default(none) private(r) shared(m, tmp) private(j)
    for (i = 0; i < N; i++) {
      for (j = 0; j < N; j++) {
        double v = 0;
        for (r = 0; r < N; r++) {
          v += m[i][r] * m[r][j];
        }
        tmp[i][j] = v;
      }
    }
    memcpy(m, tmp, sizeof(tmp));
  }

  print_matrix();

  return 0;
}
